<template>
  <div class="full-page" :class="{ 'nav-open': $sidebar.showSidebar }">
    <md-toolbar
      md-elevation="0"
      class="md-transparent md-toolbar-absolute top-toolbar"
    >
      <div class="md-toolbar-row contents-inner">
        <a href="/">
          <div>
            <img
              src="../../assets/images/jollygood_plus_logo.png"
              class="top-logo"
              decoding="async"
            />
          </div>
        </a>
        <div v-if="!responsive" class="main-sidebar">
          <div
            style="
              display: inline-block;
              position: absolute;
              right: 16px;
              top: 2px;
            "
          >
            <p class="toolbar-text mr-3">
              <a
                :href="aboutURL"
                target="_blank"
                style="color: black !important"
              >
                {{ $t('what_jollygoodplus') }}
              </a>
            </p>
            <md-menu
              md-size="medium"
              md-align-trigger
              class="toolbar-text mr-3"
              style="margin-left: 4.5px"
            >
              <p class="toolbar-text" md-menu-trigger>対象施設・機関</p>
              <md-menu-content>
                <a
                  :href="medicalInstitutionURL"
                  class="case-study"
                  target="_blank"
                >
                  <md-menu-item class="case-study-text">
                    医療機関
                  </md-menu-item>
                </a>
                <a :href="schoolAgeURL" class="case-study" target="_blank">
                  <md-menu-item class="case-study-text">
                    児童福祉施設
                  </md-menu-item>
                </a>
                <a :href="jobSupportURL" class="case-study" target="_blank">
                  <md-menu-item class="case-study-text">
                    就労支援施設
                  </md-menu-item>
                </a>
              </md-menu-content>
            </md-menu>
            <p class="toolbar-text mr-3" style="margin-left: 4.5px">
              <a
                :href="priceURL"
                target="_blank"
                style="color: black !important"
              >
                {{ $t('price_plan') }}
              </a>
            </p>
            <p class="toolbar-text mr-3" style="margin-left: 4.5px">
              <a
                :href="contactURL"
                target="_blank"
                style="color: black !important"
              >
                {{ $t('contact_us') }}
              </a>
            </p>
            <p class="toolbar-text mr-3" style="margin-left: 4.5px">
              <a
                :href="enVersionURL"
                target="_blank"
                style="color: black !important"
              >
                English
              </a>
            </p>

            <div
              style="
                display: inline-block;
                margin-left: 4.5px;
                margin-right: 4.5px;
              "
            >
              <a href="/accounts/sign_in">
                <button class="c-gradient-darkblue toolbar-button">
                  {{ $t('sign_in') }}
                </button>
              </a>
            </div>
            <div style="display: inline-block">
              <a href="/accounts/sign_up">
                <button class="c-gradient-lightblue toolbar-button">
                  {{ $t('new_registration') }}
                </button>
              </a>
            </div>
          </div>
        </div>

        <div class="md-toolbar-section-end">
          <md-button
            v-if="responsive"
            class="md-just-icon md-simple md-round md-toolbar-toggle"
            :class="{ toggled: $sidebar.showSidebar }"
            @click="toggleSidebar"
          >
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </md-button>

          <div
            v-if="responsive"
            class="md-collapse"
            :class="{ 'off-canvas-sidebar': responsive }"
          >
            <md-list>
              <md-list-item :href="aboutURL" target="_blank">
                {{ $t('what_jollygoodplus') }}
              </md-list-item>
              <md-list-item md-expand>
                対象施設・機関

                <md-list slot="md-expand">
                  <md-list-item :href="medicalInstitutionURL" target="_blank">
                    医療機関
                  </md-list-item>
                  <md-list-item :href="schoolAgeURL" target="_blank">
                    児童福祉施設
                  </md-list-item>
                  <md-list-item :href="jobSupportURL" target="_blank">
                    就労支援施設
                  </md-list-item>
                </md-list>
              </md-list-item>
              <md-list-item :href="priceURL" target="_blank">
                {{ $t('price_plan') }}
              </md-list-item>
              <md-list-item :href="contactURL" target="_blank">
                {{ $t('contact_us') }}
              </md-list-item>
              <md-list-item :href="enVersionURL" target="_blank">
                English
              </md-list-item>

              <md-list-item
                href="/accounts/sign_in"
                class="c-gradient-darkblue toolbar-button"
              >
                {{ $t('sign_in') }}
              </md-list-item>
              <md-list-item
                href="/accounts/sign_up"
                class="c-gradient-lightblue toolbar-button"
              >
                {{ $t('new_registration') }}
              </md-list-item>
            </md-list>
          </div>
        </div>
      </div>
    </md-toolbar>
    <div>
      <div>
        <div class="container top-page-offset">
          <zoom-center-transition
            :duration="pageTransitionDuration"
            mode="out-in"
          >
            <router-view
              class="top-page-margin"
              v-on:getScenarioListType="getScenarioListType"
            ></router-view>
          </zoom-center-transition>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import '/src/packs/home_overrides.css';

import { mapGetters, mapActions } from 'vuex';
import { ZoomCenterTransition } from '@/utils/transitions';
import blurBackground from '../../assets/images/jollygood_plus_blur_background.png';

export default {
  components: {
    ZoomCenterTransition,
  },
  props: {
    backgroundColor: {
      type: String,
      default: 'black',
    },
  },
  inject: {
    autoClose: {
      default: true,
    },
  },
  data() {
    return {
      responsive: false,
      showMenu: false,
      menuTransitionDuration: 250,
      pageTransitionDuration: 0,
      scenarioListType: null,
      isJapanese: true, // 日本語のときtrue
      jollygoodURL: 'https://jollygood.co.jp/about',
      aboutURL: '/about/',
      priceURL: '/about/price/',
      contactURL: '/about/contact/',
      enVersionURL: '/about/en/',
      medicalInstitutionURL: '/about/medical-institution/',
      schoolAgeURL: '/about/schoolage/',
      jobSupportURL: '/about/jobsupport/',
    };
  },
  watch: {
    $route(to, from) {
      document.title = this.changePageTitle(this.$route.name);
    },
  },
  computed: {
    ...mapGetters(['userState', 'userSignedIn']),
    setBgImage() {
      if (
        this.$route.path == '/' ||
        this.$route.path.startsWith('/libraries')
      ) {
        return {
          backgroundImage: `none`,
        };
      } else {
        return {
          backgroundImage: `url(${blurBackground})`,
        };
      }
    },
    setPageClass() {
      return `${this.$route.name}-page`.toLowerCase();
    },
  },
  methods: {
    changePageTitle: function (name) {
      var title = this.$t('site_title');

      if (name == 'public_libraries') {
        return title;
      }
      return this.$t(name) + ' | ' + this.$t('jollygoodplus');
    },
    toggleSidebarPage() {
      if (this.$sidebar.showSidebar) {
        this.$sidebar.displaySidebar(false);
      }
    },
    linkClick() {
      if (
        this.autoClose &&
        this.$sidebar &&
        this.$sidebar.showSidebar === true
      ) {
        this.$sidebar.displaySidebar(false);
      }
    },
    toggleSidebar() {
      this.$sidebar.displaySidebar(!this.$sidebar.showSidebar);
    },
    toggleNavbar() {
      document.body.classList.toggle('nav-open');
      this.showMenu = !this.showMenu;
    },
    closeMenu() {
      document.body.classList.remove('nav-open');
      this.showMenu = false;
    },
    onResponsiveInverted() {
      if (window.innerWidth < 991) {
        this.responsive = true;
      } else {
        this.responsive = false;
        this.$sidebar.displaySidebar(false);
      }
    },
    getScenarioListType(scenarioListType) {
      this.scenarioListType = scenarioListType;
    },
    changeLanguage(locale) {
      this.$i18n.locale = locale;
      this.isJapanese = locale == 'ja';
    },
  },
  mounted() {
    this.onResponsiveInverted();
    window.addEventListener('resize', this.onResponsiveInverted);
    document.title = this.changePageTitle(this.$route.name);

    // 日本語・英語切り替え
    this.$i18n.locale =
      (window.navigator.languages && window.navigator.languages[0]) ||
      window.navigator.language ||
      window.navigator.userLanguage ||
      window.navigator.browserLanguage;

    this.isJapanese = this.$i18n.locale == 'ja';
  },
  beforeUnmount() {
    this.closeMenu();
    window.removeEventListener('resize', this.onResponsiveInverted);
  },
  beforeRouteUpdate(to, from, next) {
    // Close the mobile menu first then transition to next page
    if (this.showMenu) {
      this.closeMenu();
      setTimeout(() => {
        next();
      }, this.menuTransitionDuration);
    } else {
      next();
    }
  },
};
</script>

<style lang="scss" scoped>
.top-toolbar[data-v-04c53416] {
  background: hsla(0, 0%, 100%, 0.8) !important;
  -webkit-backdrop-filter: blur(24px);
  backdrop-filter: blur(24px);
  position: fixed !important;
}

.md-layout-item {
  padding: 0;
}
$scaleSize: 0.1;
$zoomOutStart: 0.7;
$zoomOutEnd: 0.46;
@keyframes zoomIn8 {
  from {
    opacity: 0;
    transform: scale3d($scaleSize, $scaleSize, $scaleSize);
  }
  100% {
    opacity: 1;
  }
}
.wrapper-full-page .zoomIn {
  animation-name: zoomIn8;
}
@keyframes zoomOut8 {
  from {
    opacity: 1;
    transform: scale3d($zoomOutStart, $zoomOutStart, $zoomOutStart);
  }
  to {
    opacity: 0;
    transform: scale3d($zoomOutEnd, $zoomOutEnd, $zoomOutEnd);
  }
}
.wrapper-full-page .zoomOut {
  animation-name: zoomOut8;
}

@media screen and (max-width: 767px) {
  .top-logo {
    margin-left: 15px;
  }
  .footer {
    margin: 0 15px;
  }
}

.md-title img {
  height: 50px;
}
.top-bg-image {
  background-repeat: no-repeat;
  background-attachment: local;
  object-fit: cover;
  background-size: 100% auto;
}

::v-deep .main-sidebar .md-list-item-content {
  font-weight: bold !important;
  text-align: center !important;
}
::v-deep body {
  letter-spacing: unset;
  color: #3c4858;
}
html.md-theme-default {
  background-color: #fafafa;
  color: rgba(0, 0, 0, 0.87);
}
.header-filter:before {
  background: none;
}
.toolbar-text {
  cursor: pointer;
  font-weight: bold;
  font-size: 14px;
  display: inline-block;
  color: black;
}
button.toolbar-button {
  cursor: pointer;
  display: block;
  width: 100px;
  height: 30px;
  border-radius: 1.5rem;
  font-size: 12px;
  font-family: '游ゴシック体', YuGothic, '游ゴシック', 'Yu Gothic', sans-serif;
  font-weight: bold;
  text-align: center;
  border: none;
}
.top-logo {
  margin-bottom: 4px;
  margin-right: 16px;
  height: 15px;
}
.case-study:hover {
  opacity: 0.7;
}
::v-deep .md-list-item-container {
  font-size: 14px !important;
  text-align: center;
}
.size-middle {
  font-size: 14px;
}
.size-small {
  font-size: 12px !important;
}
::v-deep .md-list-expand-icon svg {
  fill: white !important;
}
.wrapper.wrapper-full-page .footer {
  position: static;
  background-color: #ffffff !important;
}
.page-header {
  flex-direction: column;
}
.top-toolbar {
  background: rgba(255, 255, 255, 0.8) !important;
  backdrop-filter: blur(24px);
  position: fixed;
}
.main-sidebar .md-list-item-container {
  font-size: 14px;
}
::v-deep .main-sidebar .md-button-content {
  font-size: 14px !important;
  font-weight: bold !important;
}
::v-deep .main-sidebar .md-list-item .md-list-item-container .md-ripple {
  padding: 0 15px;
}
::v-deep.full-page .md-toolbar .md-toolbar-toggle .icon-bar {
  color: black !important;
}
::v-deep .off-canvas-sidebar:after {
  height: 2000px;
}
::v-deep .md-toolbar {
  padding: 0;
}
::v-deep .main-sidebar .md-list-item-container {
  font-size: 14px;
}
::v-deep .off-canvas-sidebar .md-list-item-container {
  font-size: 14px;
}
.mr-3 {
  margin-right: 1rem;
}
.footer-logo {
  margin-top: 0;
  height: 30px !important;
}
.top-page-offset {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin: auto !important;
  max-width: 1440px;
  padding: 0 !important;
}
.top-page-margin {
  margin-top: 56px;
}
::v-deep .md-button.md-round,
.md-button.md-round.md-just-icon {
  margin-right: 8px;
}
::v-deep .toggled {
  margin-right: -75px !important;
}
.full-page.nav-open .wrapper-full-page {
  -webkit-transform: translate3d(-200px, 0, 0);
  transform: translate3d(-200px, 0, 0);
}
.md-list-item.toolbar-button {
  border-radius: 1.5rem;
  text-align: center !important;
}

@media screen and (max-width: 991px) {
  .off-canvas-sidebar.md-collapse {
    width: 200px;
  }
}
</style>
